Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.ExtLibs/HeuristicLab.OrTools/6.10.0/HeuristicLab.OrTools-6.10.0/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.ExtLibs/HeuristicLab.OrTools/6.10.0/HeuristicLab.OrTools-6.10.0/Properties/AssemblyInfo.cs.frame	(revision 16373)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.ExtLibs/HeuristicLab.OrTools/6.10.0/HeuristicLab.OrTools-6.10.0/Properties/AssemblyInfo.cs.frame	(revision 16373)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.OrTools")]
+[assembly: AssemblyDescription("Plugin for providing Google OR-Tools functionality in HeuristicLab")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HEAL")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2018 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("D7426305-B35E-47AF-8B19-7081C4AB76D3")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("6.10.0.0")]
+[assembly: AssemblyFileVersion("6.10.0.$WCREV$")]
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/HeuristicLab.MathematicalOptimization-3.3.csproj
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/HeuristicLab.MathematicalOptimization-3.3.csproj	(revision 16372)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/HeuristicLab.MathematicalOptimization-3.3.csproj	(revision 16373)
@@ -115,7 +115,7 @@
       <HintPath>..\..\bin\Google.OrTools.dll</HintPath>
     </Reference>
-    <Reference Include="HeuristicLab.OrTools-6.9.0-pre, Version=6.8.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+    <Reference Include="HeuristicLab.OrTools-6.10.0, Version=6.10.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\bin\HeuristicLab.OrTools-6.9.0-pre.dll</HintPath>
+      <HintPath>..\..\bin\HeuristicLab.OrTools-6.10.0.dll</HintPath>
     </Reference>
     <Reference Include="System" />
@@ -136,23 +136,23 @@
     <Compile Include="LinearProgramming\Algorithms\Solvers\Base\ExternalIncrementalSolver.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\Base\IncrementalSolver.cs" />
-    <Compile Include="LinearProgramming\Algorithms\LinearProgrammingType.cs" />
+    <Compile Include="LinearProgramming\Algorithms\ProblemType.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\ScipSolver.cs" />
-    <Compile Include="LinearProgramming\BasisStatus.cs" />
+    <Compile Include="LinearProgramming\Wrapper\BasisStatus.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\CplexSolver.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\GurobiSolver.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\Base\ISolver.cs" />
-    <Compile Include="LinearProgramming\IncrementalityValues.cs" />
-    <Compile Include="LinearProgramming\IntegerParam.cs" />
-    <Compile Include="LinearProgramming\LpAlgorithmValues.cs" />
+    <Compile Include="LinearProgramming\Wrapper\IncrementalityValues.cs" />
+    <Compile Include="LinearProgramming\Wrapper\IntegerParam.cs" />
+    <Compile Include="LinearProgramming\Wrapper\LpAlgorithmValues.cs" />
     <Compile Include="LinearProgramming\Problems\ILinearProgrammingProblemDefinition.cs" />
     <Compile Include="LinearProgramming\Algorithms\LinearProgrammingAlgorithm.cs" />
     <Compile Include="LinearProgramming\Problems\LinearProgrammingProblem.cs" />
-    <Compile Include="LinearProgramming\LinearSolverExtensions.cs" />
-    <Compile Include="LinearProgramming\LinearSolver.cs" />
+    <Compile Include="LinearProgramming\Wrapper\LinearSolverExtensions.cs" />
+    <Compile Include="LinearProgramming\Wrapper\LinearSolver.cs" />
     <Compile Include="LinearProgramming\Problems\LinearProgrammingProblemDefintion.cs" />
-    <Compile Include="LinearProgramming\OptimizationProblemType.cs" />
+    <Compile Include="LinearProgramming\Wrapper\OptimizationProblemType.cs" />
     <Compile Include="LinearProgramming\Problems\ProblemDefinitionScriptException.cs" />
     <Compile Include="LinearProgramming\Algorithms\Solvers\Base\Solver.cs" />
-    <Compile Include="LinearProgramming\DoubleParam.cs" />
+    <Compile Include="LinearProgramming\Wrapper\DoubleParam.cs" />
     <Compile Include="LinearProgramming\Views\LinearProgrammingProblemDefinitionScriptView.cs">
       <SubType>UserControl</SubType>
@@ -161,5 +161,6 @@
       <DependentUpon>LinearProgrammingProblemDefinitionScriptView.cs</DependentUpon>
     </Compile>
-    <Compile Include="LinearProgramming\ResultStatus.cs" />
+    <Compile Include="LinearProgramming\Wrapper\ProtoWriteFormat.cs" />
+    <Compile Include="LinearProgramming\Wrapper\ResultStatus.cs" />
     <Compile Include="LinearProgramming\Views\LinearProgrammingProblemView.cs">
       <SubType>UserControl</SubType>
@@ -175,4 +176,5 @@
       <DependentUpon>ScriptTemplates.resx</DependentUpon>
     </Compile>
+    <Compile Include="LinearProgramming\Wrapper\SolverResponseStatus.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
@@ -181,5 +183,7 @@
       <DependentUpon>Settings.settings</DependentUpon>
     </Compile>
-    <None Include="app.config" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
     <None Include="Plugin.cs.frame" />
     <Compile Include="Plugin.cs" />
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LinearProgrammingAlgorithm.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LinearProgrammingAlgorithm.cs	(revision 16372)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/LinearProgrammingAlgorithm.cs	(revision 16373)
@@ -35,6 +35,7 @@
 namespace HeuristicLab.MathematicalOptimization.LinearProgramming.Algorithms {
 
-  [Item("Linear/Mixed Integer Programming (LP/MIP)", "")]
-  [Creatable(CreatableAttribute.Categories.SingleSolutionAlgorithms)]
+  [Item("Linear/Mixed Integer Programming (LP/MIP)", "Linear/mixed integer programming implemented in several solvers. " +
+    "See also https://dev.heuristiclab.com/trac.fcgi/wiki/Documentation/Howto/LinearMixedIntegerProgramming")] // TODO: update link
+  [Creatable(CreatableAttribute.Categories.ExactAlgorithms)]
   [StorableClass]
   public class LinearProgrammingAlgorithm : BasicAlgorithm {
@@ -53,5 +54,5 @@
 
     [Storable]
-    private readonly IFixedValueParameter<DoubleValue> relativeGapToleranceParam;
+    private readonly IFixedValueParameter<PercentValue> relativeGapToleranceParam;
 
     [Storable]
@@ -65,6 +66,6 @@
 
     public IConstrainedValueParameter<ISolver> SolverParameter {
-      get { return solverParam; }
-      set { solverParam = value; }
+      get => solverParam;
+      set => solverParam = value;
     }
 
@@ -72,6 +73,17 @@
       Parameters.Add(solverParam =
         new ConstrainedValueParameter<ISolver>(nameof(Solver), "The solver used to solve the model."));
-      Parameters.Add(relativeGapToleranceParam = new FixedValueParameter<DoubleValue>(nameof(RelativeGapTolerance),
-        "Limit for relative MIP gap.", new DoubleValue(MPSolverParameters.kDefaultRelativeMipGap)));
+
+      ISolver defaultSolver;
+      solverParam.ValidValues.Add(new BopSolver());
+      solverParam.ValidValues.Add(defaultSolver = new CoinOrSolver());
+      solverParam.ValidValues.Add(new CplexSolver());
+      solverParam.ValidValues.Add(new GlopSolver());
+      solverParam.ValidValues.Add(new GlpkSolver());
+      solverParam.ValidValues.Add(new GurobiSolver());
+      solverParam.ValidValues.Add(new ScipSolver());
+      solverParam.Value = defaultSolver;
+
+      Parameters.Add(relativeGapToleranceParam = new FixedValueParameter<PercentValue>(nameof(RelativeGapTolerance),
+        "Limit for relative MIP gap.", new PercentValue(MPSolverParameters.kDefaultRelativeMipGap)));
       Parameters.Add(timeLimitParam = new FixedValueParameter<TimeSpanValue>(nameof(TimeLimit),
         "Limit for runtime. Set to zero for unlimited runtime.", new TimeSpanValue()));
@@ -92,12 +104,4 @@
 
       Problem = new LinearProgrammingProblem();
-
-      solverParam.ValidValues.Add(new CoinOrSolver());
-      solverParam.ValidValues.Add(new CplexSolver());
-      solverParam.ValidValues.Add(new GlpkSolver());
-      solverParam.ValidValues.Add(new GurobiSolver());
-      solverParam.ValidValues.Add(new ScipSolver());
-      solverParam.ValidValues.Add(new BopSolver());
-      solverParam.ValidValues.Add(new GlopSolver());
     }
 
@@ -176,5 +180,5 @@
     public override void Pause() {
       base.Pause();
-      Solver.Interrupt();
+      Solver.InterruptSolve();
     }
 
@@ -190,9 +194,5 @@
     public override void Stop() {
       base.Stop();
-      Solver.Interrupt();
-    }
-
-    protected override void Initialize(CancellationToken cancellationToken) {
-      base.Initialize(cancellationToken);
+      Solver.InterruptSolve();
     }
 
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs	(revision 16373)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/ProblemType.cs	(revision 16373)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.MathematicalOptimization.LinearProgramming.Algorithms {
+
+  public enum ProblemType {
+    LinearProgramming,
+    MixedIntegerProgramming
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalSolver.cs	(revision 16372)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IIncrementalSolver.cs	(revision 16373)
@@ -25,6 +25,6 @@
 
   public interface IIncrementalSolver : ISolver {
-    bool Incrementality { get; set; }
     TimeSpan QualityUpdateInterval { get; set; }
+    bool SupportsQualityUpdate { get; }
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ISolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ISolver.cs	(revision 16372)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/ISolver.cs	(revision 16373)
@@ -26,9 +26,9 @@
 
   public interface ISolver : IParameterizedNamedItem {
-    LinearProgrammingType LinearProgrammingType { get; set; }
+    ProblemType ProblemType { get; set; }
     bool SupportsPause { get; }
     bool SupportsStop { get; }
 
-    void Interrupt();
+    bool InterruptSolve();
 
     void Reset();
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IncrementalSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IncrementalSolver.cs	(revision 16372)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/IncrementalSolver.cs	(revision 16373)
@@ -23,5 +23,4 @@
 using System.Linq;
 using System.Threading;
-using Google.OrTools.LinearSolver;
 using HeuristicLab.Analysis;
 using HeuristicLab.Common;
@@ -35,7 +34,4 @@
   [StorableClass]
   public class IncrementalSolver : Solver, IIncrementalSolver {
-
-    [Storable]
-    protected readonly IValueParameter<BoolValue> incrementalityParam;
 
     [Storable]
@@ -55,17 +51,15 @@
 
     public IncrementalSolver() {
-      Parameters.Add(incrementalityParam = new ValueParameter<BoolValue>(nameof(Incrementality),
-        "Advanced usage: incrementality from one solve to the next.",
-        new BoolValue(MPSolverParameters.kDefaultIncrementality == MPSolverParameters.INCREMENTALITY_ON)));
       Parameters.Add(qualityUpdateIntervalParam =
         new ValueParameter<TimeSpanValue>(nameof(QualityUpdateInterval),
-          "Time interval before solver is paused, resuls are retrieved and solver is resumed.",
-          new TimeSpanValue(new TimeSpan(0, 0, 10))));
-
-      incrementalityParam.Value.ValueChanged += (sender, args) => {
-        if (((BoolValue)sender).Value) {
-          qualityUpdateIntervalParam.Value = new TimeSpanValue(qualityUpdateIntervalParam.Value.Value);
+          "Time interval before solver is paused, results are retrieved and solver is resumed. " +
+          "Set to zero for no intermediate results and faster solving.", new TimeSpanValue(new TimeSpan(0, 0, 10))));
+      problemTypeParam.Value.ValueChanged += (sender, args) => {
+        if (SupportsQualityUpdate) {
+          if (!Parameters.Contains(qualityUpdateIntervalParam)) {
+            Parameters.Add(qualityUpdateIntervalParam);
+          }
         } else {
-          qualityUpdateIntervalParam.Value = (TimeSpanValue)qualityUpdateIntervalParam.Value.AsReadOnly();
+          Parameters.Remove(qualityUpdateIntervalParam);
         }
       };
@@ -74,15 +68,11 @@
     protected IncrementalSolver(IncrementalSolver original, Cloner cloner)
         : base(original, cloner) {
-      programmingTypeParam = cloner.Clone(original.programmingTypeParam);
+      problemTypeParam = cloner.Clone(original.problemTypeParam);
       qualityUpdateIntervalParam = cloner.Clone(original.qualityUpdateIntervalParam);
-      incrementalityParam = cloner.Clone(original.incrementalityParam);
       if (original.qualityPerClock != null)
         qualityPerClock = cloner.Clone(original.qualityPerClock);
     }
 
-    public bool Incrementality {
-      get => incrementalityParam.Value.Value;
-      set => incrementalityParam.Value.Value = value;
-    }
+    public virtual bool SupportsQualityUpdate => true;
 
     public TimeSpan QualityUpdateInterval {
@@ -91,6 +81,8 @@
     }
 
+    protected virtual TimeSpan TimeLimit => QualityUpdateInterval;
+
     public override void Solve(LinearProgrammingAlgorithm algorithm, CancellationToken cancellationToken) {
-      if (!Incrementality) {
+      if (!SupportsQualityUpdate || QualityUpdateInterval == TimeSpan.Zero) {
         base.Solve(algorithm, cancellationToken);
         return;
@@ -101,20 +93,20 @@
 
       if (!unlimitedRuntime) {
-        var wallTime = ((TimeSpanValue)algorithm.Results.SingleOrDefault(r => r.Name == "Wall Time")?.Value)?.Value;
-        if (wallTime.HasValue) {
-          timeLimit -= wallTime.Value;
-        }
+        timeLimit -= algorithm.ExecutionTime;
       }
 
       var iterations = (long)timeLimit.TotalMilliseconds / (long)QualityUpdateInterval.TotalMilliseconds;
       var remaining = timeLimit - TimeSpan.FromMilliseconds(iterations * QualityUpdateInterval.TotalMilliseconds);
-      var validResultStatuses = new[] { ResultStatus.NOT_SOLVED, ResultStatus.FEASIBLE };
+      var validResultStatuses = new[] { ResultStatus.NotSolved, ResultStatus.Feasible };
 
       while (unlimitedRuntime || iterations > 0) {
-        base.Solve(algorithm, QualityUpdateInterval, true);
+        if (cancellationToken.IsCancellationRequested)
+          return;
+
+        base.Solve(algorithm, TimeLimit);
         UpdateQuality(algorithm);
 
-        var resultStatus = ((EnumValue<ResultStatus>)algorithm.Results["Result Status"].Value).Value;
-        if (!validResultStatuses.Contains(resultStatus) || cancellationToken.IsCancellationRequested)
+        var resultStatus = ((EnumValue<ResultStatus>)algorithm.Results[nameof(solver.ResultStatus)].Value).Value;
+        if (!validResultStatuses.Contains(resultStatus))
           return;
 
@@ -124,5 +116,5 @@
 
       if (remaining > TimeSpan.Zero) {
-        base.Solve(algorithm, remaining, true);
+        base.Solve(algorithm, remaining);
         UpdateQuality(algorithm);
       }
@@ -132,16 +124,16 @@
       if (!algorithm.Results.Exists(r => r.Name == "QualityPerClock")) {
         qualityPerClock = new IndexedDataTable<double>("Quality per Clock");
-        qpcRow = new IndexedDataRow<double>("First-hit Graph Objective");
-        bpcRow = new IndexedDataRow<double>("First-hit Graph Bound");
+        qpcRow = new IndexedDataRow<double>("Objective Value");
+        bpcRow = new IndexedDataRow<double>("Bound");
         algorithm.Results.AddOrUpdateResult("QualityPerClock", qualityPerClock);
       }
 
-      var resultStatus = ((EnumValue<ResultStatus>)algorithm.Results["Result Status"].Value).Value;
+      var resultStatus = ((EnumValue<ResultStatus>)algorithm.Results[nameof(solver.ResultStatus)].Value).Value;
 
-      if (new[] { ResultStatus.ABNORMAL, ResultStatus.NOT_SOLVED, ResultStatus.UNBOUNDED }.Contains(resultStatus))
+      if (new[] { ResultStatus.Abnormal, ResultStatus.NotSolved, ResultStatus.Unbounded }.Contains(resultStatus))
         return;
 
-      var objective = ((DoubleValue)algorithm.Results["Best Objective Value"].Value).Value;
-      var bound = ((DoubleValue)algorithm.Results["Best Objective Bound"].Value).Value;
+      var objective = ((DoubleValue)algorithm.Results[$"Best{nameof(solver.ObjectiveValue)}"].Value).Value;
+      var bound = solver.IsMip ? ((DoubleValue)algorithm.Results[$"Best{nameof(solver.ObjectiveBound)}"].Value).Value : double.NaN;
       var time = algorithm.ExecutionTime.TotalSeconds;
 
@@ -151,5 +143,5 @@
           qpcRow.Values.Add(Tuple.Create(time, objective));
           qualityPerClock.Rows.Add(qpcRow);
-          algorithm.Results.AddOrUpdateResult("Best Solution Found At", new TimeSpanValue(TimeSpan.FromSeconds(time)));
+          algorithm.Results.AddOrUpdateResult($"Best{nameof(solver.ObjectiveValue)}FoundAt", new TimeSpanValue(TimeSpan.FromSeconds(time)));
         }
       } else {
@@ -158,7 +150,10 @@
         if (!objective.IsAlmost(previousBest)) {
           qpcRow.Values.Add(Tuple.Create(time, objective));
-          algorithm.Results.AddOrUpdateResult("Best Solution Found At", new TimeSpanValue(TimeSpan.FromSeconds(time)));
+          algorithm.Results.AddOrUpdateResult($"Best{nameof(solver.ObjectiveValue)}FoundAt", new TimeSpanValue(TimeSpan.FromSeconds(time)));
         }
       }
+
+      if (!solver.IsMip)
+        return;
 
       if (!bpcRow.Values.Any()) {
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/Solver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/Solver.cs	(revision 16372)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/Base/Solver.cs	(revision 16373)
@@ -34,12 +34,16 @@
 
     [Storable]
-    protected IValueParameter<EnumValue<LinearProgrammingType>> programmingTypeParam;
+    protected IValueParameter<EnumValue<ProblemType>> problemTypeParam;
 
     protected LinearSolver solver;
 
+    [Storable]
+    protected IFixedValueParameter<TextValue> solverSpecificParametersParam;
+
     public Solver() {
-      Parameters.Add(programmingTypeParam =
-        new ValueParameter<EnumValue<LinearProgrammingType>>(nameof(LinearProgrammingType),
-          new EnumValue<LinearProgrammingType>()));
+      Parameters.Add(problemTypeParam =
+        new ValueParameter<EnumValue<ProblemType>>(nameof(ProblemType), new EnumValue<ProblemType>()));
+      Parameters.Add(solverSpecificParametersParam =
+        new FixedValueParameter<TextValue>(nameof(SolverSpecificParameters), new TextValue()));
     }
 
@@ -51,15 +55,18 @@
     protected Solver(Solver original, Cloner cloner)
       : base(original, cloner) {
-      programmingTypeParam = cloner.Clone(original.programmingTypeParam);
+      problemTypeParam = cloner.Clone(original.problemTypeParam);
+      solverSpecificParametersParam = cloner.Clone(original.solverSpecificParametersParam);
     }
 
-    public LinearProgrammingType LinearProgrammingType {
-      get => programmingTypeParam.Value.Value;
-      set => programmingTypeParam.Value.Value = value;
+    public ProblemType ProblemType {
+      get => problemTypeParam.Value.Value;
+      set => problemTypeParam.Value.Value = value;
     }
 
+    public TextValue SolverSpecificParameters => solverSpecificParametersParam.Value;
+
+    public virtual bool SupportsPause => true;
+    public virtual bool SupportsStop => true;
     protected virtual OptimizationProblemType OptimizationProblemType { get; }
-    public virtual bool SupportsPause => false;
-    public virtual bool SupportsStop => false;
 
     public override IDeepCloneable Clone(Cloner cloner) => new Solver(this, cloner);
@@ -67,5 +74,5 @@
     public void Dispose() => solver?.Dispose();
 
-    public void Interrupt() => solver.Stop();
+    public bool InterruptSolve() => solver?.InterruptSolve() ?? false;
 
     public virtual void Reset() {
@@ -78,7 +85,7 @@
 
     public virtual void Solve(LinearProgrammingAlgorithm algorithm) =>
-      Solve(algorithm, algorithm.TimeLimit, false);
+      Solve(algorithm, algorithm.TimeLimit);
 
-    public virtual void Solve(LinearProgrammingAlgorithm algorithm, TimeSpan timeLimit, bool incrementality) {
+    public virtual void Solve(LinearProgrammingAlgorithm algorithm, TimeSpan timeLimit) {
       string libraryName = null;
       if (this is IExternalSolver externalSolver)
@@ -86,6 +93,6 @@
 
       if (solver == null) {
-        solver = LinearSolver.CreateSolver(OptimizationProblemType, Name,
-          libraryName, s => algorithm.Problem.ProblemDefinition.BuildModel(s));
+        solver = new LinearSolver(OptimizationProblemType, s => algorithm.Problem.ProblemDefinition.BuildModel(s), Name,
+          libraryName);
       }
 
@@ -97,22 +104,35 @@
       solver.Scaling = algorithm.Scaling;
       solver.LpAlgorithm = algorithm.LpAlgorithm;
-      solver.Incrementality = incrementality;
+      solver.Incrementality = true;
+
+      if (!solver.SetSolverSpecificParameters(SolverSpecificParameters.Value))
+        throw new ArgumentException("Solver specific parameters could not be set.");
 
       solver.Solve();
 
       algorithm.Problem.ProblemDefinition.Analyze(solver.Solver, algorithm.Results);
-      algorithm.Results.AddOrUpdateResult("Result Status", new EnumValue<ResultStatus>(solver.ResultStatus));
-      algorithm.Results.AddOrUpdateResult("Best Objective Value",
+      algorithm.Results.AddOrUpdateResult(nameof(solver.ResultStatus),
+        new EnumValue<ResultStatus>(solver.ResultStatus));
+      algorithm.Results.AddOrUpdateResult($"Best{nameof(solver.ObjectiveValue)}",
         new DoubleValue(solver.ObjectiveValue ?? double.NaN));
-      algorithm.Results.AddOrUpdateResult("Best Objective Bound",
-        new DoubleValue(solver.ObjectiveBound ?? double.NaN));
-      algorithm.Results.AddOrUpdateResult("Absolute Gap", new DoubleValue(solver.AbsoluteGap ?? double.NaN));
-      algorithm.Results.AddOrUpdateResult("Relative Gap", new DoubleValue(solver.RelativeGap ?? double.NaN));
-      algorithm.Results.AddOrUpdateResult("Number of Constraints", new IntValue(solver.NumberOfConstraints));
-      algorithm.Results.AddOrUpdateResult("Number of Variables", new IntValue(solver.NumberOfVariables));
-      algorithm.Results.AddOrUpdateResult("Number of Nodes", new DoubleValue(solver.NumberOfNodes));
-      algorithm.Results.AddOrUpdateResult("Iterations", new DoubleValue(solver.Iterations));
-      algorithm.Results.AddOrUpdateResult("Solver Version", new StringValue(solver.SolverVersion));
-      algorithm.Results.AddOrUpdateResult("Wall Time", new TimeSpanValue(solver.WallTime ?? TimeSpan.Zero));
+
+      if (solver.IsMip) {
+        algorithm.Results.AddOrUpdateResult($"Best{nameof(solver.ObjectiveBound)}",
+          new DoubleValue(solver.ObjectiveBound ?? double.NaN));
+        algorithm.Results.AddOrUpdateResult(nameof(solver.AbsoluteGap),
+          new DoubleValue(solver.AbsoluteGap ?? double.NaN));
+        algorithm.Results.AddOrUpdateResult(nameof(solver.RelativeGap),
+          new PercentValue(solver.RelativeGap ?? double.NaN));
+      }
+
+      algorithm.Results.AddOrUpdateResult(nameof(solver.NumberOfConstraints), new IntValue(solver.NumberOfConstraints));
+      algorithm.Results.AddOrUpdateResult(nameof(solver.NumberOfVariables), new IntValue(solver.NumberOfVariables));
+
+      if (solver.IsMip) {
+        algorithm.Results.AddOrUpdateResult(nameof(solver.NumberOfNodes), new DoubleValue(solver.NumberOfNodes));
+      }
+
+      algorithm.Results.AddOrUpdateResult(nameof(solver.Iterations), new DoubleValue(solver.Iterations));
+      algorithm.Results.AddOrUpdateResult(nameof(solver.SolverVersion), new StringValue(solver.SolverVersion));
     }
   }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/BopSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/BopSolver.cs	(revision 16372)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/BopSolver.cs	(revision 16373)
@@ -20,7 +20,10 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.MathematicalOptimization.LinearProgramming.Algorithms.Solvers.Base;
+using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -32,5 +35,11 @@
 
     public BopSolver() {
-      Parameters.Remove(programmingTypeParam);
+      Parameters.Remove(problemTypeParam);
+      Parameters.Add(new FixedValueParameter<StringValue>(nameof(ProblemType), new StringValue("ZeroOneProgramming").AsReadOnly()));
+      SolverSpecificParameters.Value =
+        "# for file format, see Protocol Buffers text format (https://developers.google.com/protocol-buffers/docs/overview#whynotxml)" + Environment.NewLine +
+        "# for parameters, see https://github.com/google/or-tools/blob/v6.10/ortools/bop/bop_parameters.proto" + Environment.NewLine +
+        "# example:" + Environment.NewLine +
+        "# random_seed: 10" + Environment.NewLine;
     }
 
@@ -44,10 +53,6 @@
     }
 
-    public override bool SupportsPause => true;
-
-    public override bool SupportsStop => true;
-
     protected override OptimizationProblemType OptimizationProblemType =>
-              OptimizationProblemType.BOP_INTEGER_PROGRAMMING;
+               OptimizationProblemType.BopIntegerProgramming;
   }
 }
